Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c	(revision 58190)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/file.c	(revision 58195)
@@ -43,5 +43,5 @@
                                   uint8_t *pBuffer, bool fLocked)
 {
-    return vboxCallRead(pClient, pMap, hFile, offset, pcbBuffer, pBuffer, fLocked);
+    return VbglR0SfRead(pClient, pMap, hFile, offset, pcbBuffer, pBuffer, fLocked);
 }
 
@@ -50,5 +50,5 @@
                                    uint8_t *pBuffer, bool fLocked)
 {
-    return vboxCallWrite(pClient, pMap, hFile, offset, pcbBuffer, pBuffer, fLocked);
+    return VbglR0SfWrite(pClient, pMap, hFile, offset, pcbBuffer, pBuffer, fLocked);
 }
 
@@ -57,5 +57,5 @@
                                  uint16_t offFirstPage, uint16_t cPages, RTGCPHYS64 *paPages)
 {
-    return VbglR0SharedFolderReadPageList(pClient, pMap, hFile, offset, pcbBuffer, offFirstPage, cPages, paPages);
+    return VbglR0SfReadPageList(pClient, pMap, hFile, offset, pcbBuffer, offFirstPage, cPages, paPages);
 }
 
@@ -64,5 +64,5 @@
                                   uint16_t offFirstPage, uint16_t cPages, RTGCPHYS64 *paPages)
 {
-    return VbglR0SharedFolderWritePageList(pClient, pMap, hFile, offset, pcbBuffer, offFirstPage, cPages, paPages);
+    return VbglR0SfWritePageList(pClient, pMap, hFile, offset, pcbBuffer, offFirstPage, cPages, paPages);
 }
 
@@ -491,5 +491,5 @@
         fu32Lock |= SHFL_LOCK_WAIT;
 
-    vboxRC = vboxCallLock(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+    vboxRC = VbglR0SfLock(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                           LowIoContext->ParamsFor.Locks.ByteOffset, LowIoContext->ParamsFor.Locks.Length, fu32Lock);
 
@@ -524,5 +524,5 @@
 
     /* Do the actual flushing of file buffers */
-    vboxRC = vboxCallFlush(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile);
+    vboxRC = VbglR0SfFlush(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile);
 
     Status = VBoxErrorToNTStatus(vboxRC);
@@ -565,13 +565,13 @@
     pObjInfo->cbObject = pNewFileSize->QuadPart;
 
-    vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+    vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                             SHFL_INFO_SET | SHFL_INFO_SIZE, &cbBuffer, (PSHFLDIRINFO)pObjInfo);
 
-    Log(("VBOXSF: vbsfSetEndOfFile: vboxCallFSInfo returned %Rrc\n", vboxRC));
+    Log(("VBOXSF: vbsfSetEndOfFile: VbglR0SfFsInfo returned %Rrc\n", vboxRC));
 
     Status = VBoxErrorToNTStatus(vboxRC);
     if (Status == STATUS_SUCCESS)
     {
-        Log(("VBOXSF: vbsfSetEndOfFile: vboxCallFSInfo new allocation size = %RX64\n",
+        Log(("VBOXSF: vbsfSetEndOfFile: VbglR0SfFsInfo new allocation size = %RX64\n",
              pObjInfo->cbAllocated));
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c	(revision 58190)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/info.c	(revision 58195)
@@ -165,10 +165,10 @@
     cFiles = 0;
 
-    /* vboxCallDirInfo requires a pointer to uint32_t. */
+    /* VbglR0SfDirInfo requires a pointer to uint32_t. */
     u32BufSize = cbHGCMBuffer;
 
     Log(("VBOXSF: MrxQueryDirectory: CallDirInfo: File = 0x%08x, Flags = 0x%08x, Index = %d, u32BufSize = %d\n",
          pVBoxFobx->hFile, fSFFlags, index, u32BufSize));
-    vboxRC = vboxCallDirInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+    vboxRC = VbglR0SfDirInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                              ParsedPath, fSFFlags, index, &u32BufSize, (PSHFLDIRINFO)pHGCMBuffer, &cFiles);
     Log(("VBOXSF: MrxQueryDirectory: u32BufSize after CallDirInfo = %d, rc = %Rrc\n",
@@ -592,5 +592,5 @@
             }
 
-            vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                                     SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
 
@@ -765,5 +765,5 @@
             }
 
-            vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                                     SHFL_INFO_GET | SHFL_INFO_VOLUME, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
 
@@ -1098,5 +1098,5 @@
 
         Assert(pVBoxFobx && pNetRootExtension && pDeviceExtension);
-        vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+        vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                                 SHFL_INFO_GET | SHFL_INFO_FILE, &cbHGCMBuffer, (PSHFLDIRINFO)pHGCMBuffer);
 
@@ -1429,5 +1429,5 @@
 
             Assert(pVBoxFobx && pNetRootExtension && pDeviceExtension);
-            vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+            vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                                     SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
 
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c	(revision 58190)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/net.c	(revision 58195)
@@ -206,9 +206,9 @@
             }
 
-            vboxRC = vboxCallMapFolder(&pDeviceExtension->hgcmClient, ParsedPath, &pNetRootExtension->map);
+            vboxRC = VbglR0SfMapFolder(&pDeviceExtension->hgcmClient, ParsedPath, &pNetRootExtension->map);
             vbsfFreeNonPagedMem(ParsedPath);
             if (vboxRC != VINF_SUCCESS)
             {
-                Log(("VBOXSF: MRxCreateVNetRoot: vboxCallMapFolder failed with %d\n", vboxRC));
+                Log(("VBOXSF: MRxCreateVNetRoot: VbglR0SfMapFolder failed with %d\n", vboxRC));
                 Status = STATUS_BAD_NETWORK_NAME;
             }
@@ -264,7 +264,7 @@
     if (pNetRootExtension->phgcmClient)
     {
-        int vboxRC = vboxCallUnmapFolder(pNetRootExtension->phgcmClient, &pNetRootExtension->map);
+        int vboxRC = VbglR0SfUnmapFolder(pNetRootExtension->phgcmClient, &pNetRootExtension->map);
         if (vboxRC != VINF_SUCCESS)
-            Log(("VBOXSF: MRxFinalizeVNetRoot: vboxCallUnmapFolder failed with %d\n",
+            Log(("VBOXSF: MRxFinalizeVNetRoot: VbglR0SfUnmapFolder failed with %d\n",
                  vboxRC));
         pNetRootExtension->phgcmClient = NULL;
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c	(revision 58190)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/path.c	(revision 58195)
@@ -261,11 +261,11 @@
 
         /* Call host. */
-        Log(("VBOXSF: vbsfProcessCreate: vboxCallCreate called.\n"));
-        vboxRC = vboxCallCreate(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, ParsedPath, pCreateParms);
+        Log(("VBOXSF: vbsfProcessCreate: VbglR0SfCreate called.\n"));
+        vboxRC = VbglR0SfCreate(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, ParsedPath, pCreateParms);
 
         vbsfFreeNonPagedMem(ParsedPath);
     }
 
-    Log(("VBOXSF: vbsfProcessCreate: vboxCallCreate returns vboxRC = %Rrc, Result = 0x%x\n",
+    Log(("VBOXSF: vbsfProcessCreate: VbglR0SfCreate returns vboxRC = %Rrc, Result = 0x%x\n",
          vboxRC, pCreateParms->Result));
 
@@ -447,5 +447,5 @@
     if (pCreateParms && pCreateParms->Handle != SHFL_HANDLE_NIL)
     {
-        vboxCallClose(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pCreateParms->Handle);
+        VbglR0SfClose(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pCreateParms->Handle);
         *pHandle = SHFL_HANDLE_NIL;
     }
@@ -699,5 +699,5 @@
         pSHFLFileInfo->Attr.fMode = NTToVBoxFileAttributes(pInfo->FileAttributes);
 
-    vboxRC = vboxCallFSInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
+    vboxRC = VbglR0SfFsInfo(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, pVBoxFobx->hFile,
                             SHFL_INFO_SET | SHFL_INFO_FILE, &cbBuffer, (PSHFLDIRINFO)pSHFLFileInfo);
 
@@ -745,5 +745,5 @@
     }
 
-    vboxRC = vboxCallClose(&pDeviceExtension->hgcmClient,
+    vboxRC = VbglR0SfClose(&pDeviceExtension->hgcmClient,
                            &pNetRootExtension->map,
                            pVBoxFobx->hFile);
@@ -839,5 +839,5 @@
 
     /* Call host. */
-    vboxRC = vboxCallRemove(&pDeviceExtension->hgcmClient, &pNetRootExtension->map,
+    vboxRC = VbglR0SfRemove(&pDeviceExtension->hgcmClient, &pNetRootExtension->map,
                             ParsedPath,
                             (pVBoxFobx->FileStandardInfo.Directory) ? SHFL_REMOVE_DIR : SHFL_REMOVE_FILE);
@@ -851,5 +851,5 @@
     Status = VBoxErrorToNTStatus(vboxRC);
     if (vboxRC != VINF_SUCCESS)
-        Log(("VBOXSF: vbsfRemove: vboxCallRemove failed with %Rrc\n", vboxRC));
+        Log(("VBOXSF: vbsfRemove: VbglR0SfRemove failed with %Rrc\n", vboxRC));
 
     Log(("VBOXSF: vbsfRemove: Returned 0x%08X\n", Status));
@@ -915,6 +915,6 @@
         flags |= SHFL_RENAME_REPLACE_IF_EXISTS;
 
-    Log(("VBOXSF: vbsfRename: Calling vboxCallRename\n"));
-    vboxRC = vboxCallRename(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, SrcPath, DestPath, flags);
+    Log(("VBOXSF: vbsfRename: Calling VbglR0SfRename\n"));
+    vboxRC = VbglR0SfRename(&pDeviceExtension->hgcmClient, &pNetRootExtension->map, SrcPath, DestPath, flags);
 
     vbsfFreeNonPagedMem(SrcPath);
@@ -923,5 +923,5 @@
     Status = VBoxErrorToNTStatus(vboxRC);
     if (vboxRC != VINF_SUCCESS)
-        Log(("VBOXSF: vbsfRename: vboxCallRename failed with %Rrc\n", vboxRC));
+        Log(("VBOXSF: vbsfRename: VbglR0SfRename failed with %Rrc\n", vboxRC));
 
     Log(("VBOXSF: vbsfRename: Returned 0x%08X\n", Status));
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c	(revision 58190)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsf.c	(revision 58195)
@@ -82,8 +82,8 @@
         PMRX_VBOX_DEVICE_EXTENSION pDeviceExtension;
         pDeviceExtension = (PMRX_VBOX_DEVICE_EXTENSION)((PBYTE)VBoxMRxDeviceObject + sizeof(RDBSS_DEVICE_OBJECT));
-        vboxDisconnect (&pDeviceExtension->hgcmClient);
-    }
-
-    vboxUninit();
+        VbglR0SfDisconnect(&pDeviceExtension->hgcmClient);
+    }
+
+    VbglR0SfTerm();
 
     if (VBoxMRxDeviceObject)
@@ -422,5 +422,5 @@
 
     /* Initialize VBox subsystem. */
-    vboxRC = vboxInit();
+    vboxRC = VbglR0SfInit();
     if (RT_FAILURE(vboxRC))
     {
@@ -431,10 +431,10 @@
     /* Connect the HGCM client */
     RT_ZERO(hgcmClient);
-    vboxRC = vboxConnect(&hgcmClient);
+    vboxRC = VbglR0SfConnect(&hgcmClient);
     if (RT_FAILURE(vboxRC))
     {
         Log(("VBOXSF: DriverEntry: ERROR while connecting to host (%Rrc)!\n",
              vboxRC));
-        vboxUninit();
+        VbglR0SfTerm();
         return STATUS_UNSUCCESSFUL;
     }
@@ -555,6 +555,6 @@
     Log(("VBOXSF: DriverEntry: Failure! Status = 0x%08X\n", Status));
 
-    vboxDisconnect(&hgcmClient);
-    vboxUninit();
+    VbglR0SfDisconnect(&hgcmClient);
+    VbglR0SfTerm();
 
     if (VBoxMRxDeviceObject)
@@ -711,5 +711,5 @@
                         uint32_t cMappings = RT_ELEMENTS(mappings);
 
-                        int vboxRC = vboxCallQueryMappings(&pDeviceExtension->hgcmClient, mappings, &cMappings);
+                        int vboxRC = VbglR0SfQueryMappings(&pDeviceExtension->hgcmClient, mappings, &cMappings);
 
                         if (vboxRC == VINF_SUCCESS)
@@ -838,5 +838,5 @@
                         break;
 
-                    vboxRC = vboxCallQueryMapName(&pDeviceExtension->hgcmClient,
+                    vboxRC = VbglR0SfQueryMapName(&pDeviceExtension->hgcmClient,
                                                   (*pConnectId) & ~0x80 /** @todo fix properly */,
                                                   pString, ShflStringSizeOfBuffer(pString));