Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/Makefile.kmk	(revision 58202)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/Makefile.kmk	(revision 58203)
@@ -30,6 +30,4 @@
 VBoxSF_SDKS.amd64  = ReorderCompilerIncs $(VBOX_WINDDK_GST_WLH)
 
-VBoxSF_INCS        = \
-	../../../common/VBoxGuestLib
 VBoxSF_LDFLAGS.x86   = -Entry:DriverEntry@8
 VBoxSF_LDFLAGS.amd64 = -Entry:DriverEntry
Index: trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h	(revision 58202)
+++ trunk/src/VBox/Additions/WINNT/SharedFolders/driver/vbsfhlp.h	(revision 58203)
@@ -25,5 +25,6 @@
 
 #include <VBox/log.h>
-#include "VBoxGuestR0LibSharedFolders.h"
+#include <VBox/VBoxGuestLibSharedFolders.h>
+
 
 void vbsfHlpSleep (ULONG ulMillies);
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.c
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.c	(revision 58202)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.c	(revision 58203)
@@ -33,9 +33,5 @@
 *********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_SHARED_FOLDERS
-#ifdef RT_OS_LINUX
-# include "VBoxGuestR0LibSharedFolders.h"
-#else
-# include "VBoxGuestR0LibSharedFolders.h"
-#endif
+#include <VBox/VBoxGuestLibSharedFolders.h>
 #include <VBox/log.h>
 #include <iprt/time.h>
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h	(revision 58202)
+++ 	(revision )
@@ -1,109 +1,0 @@
-/* $Id$ */
-/** @file
- * VBoxGuestLib - Central calls header.
- */
-
-/*
- * Copyright (C) 2006-2015 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
- *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
- */
-
-#ifndef ___VBoxGuestLib_VBoxGuestR0LibSharedFolders_h
-#define ___VBoxGuestLib_VBoxGuestR0LibSharedFolders_h
-
-#include <VBox/VBoxGuestLib.h>
-#include <VBox/shflsvc.h>
-
-typedef struct VBGLSFCLIENT
-{
-    HGCMCLIENTID idClient;
-    VBGLHGCMHANDLE handle;
-} VBGLSFCLIENT;
-typedef VBGLSFCLIENT *PVBGLSFCLIENT;
-
-typedef struct VBGLSFMAP
-{
-    SHFLROOT root;
-} VBGLSFMAP, *PVBGLSFMAP;
-
-DECLVBGL(int)  VbglR0SfInit(void);
-DECLVBGL(void) VbglR0SfTerm(void);
-DECLVBGL(int)  VbglR0SfConnect(PVBGLSFCLIENT pClient);
-DECLVBGL(void) VbglR0SfDisconnect(PVBGLSFCLIENT pClient);
-
-DECLVBGL(int)  VbglR0SfQueryMappings(PVBGLSFCLIENT pClient, SHFLMAPPING paMappings[], uint32_t *pcMappings);
-
-DECLVBGL(int)  VbglR0SfQueryMapName(PVBGLSFCLIENT pClient, SHFLROOT root, SHFLSTRING *pString, uint32_t size);
-
-/**
- * Create a new file or folder or open an existing one in a shared folder.  Proxies
- * to vbsfCreate in the host shared folder service.
- *
- * @returns IPRT status code, but see note below
- * @param   pClient      Host-guest communication connection
- * @param   pMap         The mapping for the shared folder in which the file
- *                       or folder is to be created
- * @param   pParsedPath  The path of the file or folder relative to the shared
- *                       folder
- * @param   pCreateParms Parameters for file/folder creation.  See the
- *                       structure description in shflsvc.h
- * @retval  pCreateParms See the structure description in shflsvc.h
- *
- * @note This function reports errors as follows.  The return value is always
- *       VINF_SUCCESS unless an exceptional condition occurs - out of
- *       memory, invalid arguments, etc.  If the file or folder could not be
- *       opened or created, pCreateParms->Handle will be set to
- *       SHFL_HANDLE_NIL on return.  In this case the value in
- *       pCreateParms->Result provides information as to why (e.g.
- *       SHFL_FILE_EXISTS).  pCreateParms->Result is also set on success
- *       as additional information.
- */
-DECLVBGL(int)  VbglR0SfCreate(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, PSHFLSTRING pParsedPath, PSHFLCREATEPARMS pCreateParms);
-
-DECLVBGL(int)  VbglR0SfClose(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE Handle);
-DECLVBGL(int)  VbglR0SfRemove(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, PSHFLSTRING pParsedPath, uint32_t flags);
-DECLVBGL(int)  VbglR0SfRename(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, PSHFLSTRING pSrcPath, PSHFLSTRING pDestPath, uint32_t flags);
-DECLVBGL(int)  VbglR0SfFlush(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile);
-
-DECLVBGL(int)  VbglR0SfRead(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset, uint32_t *pcbBuffer, uint8_t *pBuffer, bool fLocked);
-DECLVBGL(int)  VbglR0SfReadPageList(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset, uint32_t *pcbBuffer,
-                                    uint16_t offFirstPage, uint16_t cPages, RTGCPHYS64 *paPages);
-DECLVBGL(int)  VbglR0SfWrite(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset,
-                             uint32_t *pcbBuffer,  uint8_t *pBuffer, bool fLocked);
-DECLVBGL(int)  VbglR0SfWritePhysCont(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset,
-                                     uint32_t *pcbBuffer, RTCCPHYS PhysBuffer);
-DECLVBGL(int)  VbglR0SfWritePageList(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset, uint32_t *pcbBuffer,
-                                     uint16_t offFirstPage, uint16_t cPages, RTGCPHYS64 *paPages);
-
-DECLVBGL(int)  VbglR0SfLock(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint64_t offset, uint64_t cbSize, uint32_t fLock);
-
-DECLVBGL(int)  VbglR0SfDirInfo(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile,PSHFLSTRING ParsedPath, uint32_t flags,
-                                 uint32_t index, uint32_t *pcbBuffer, PSHFLDIRINFO pBuffer, uint32_t *pcFiles);
-DECLVBGL(int)  VbglR0SfFsInfo(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, SHFLHANDLE hFile, uint32_t flags, uint32_t *pcbBuffer, PSHFLDIRINFO pBuffer);
-
-DECLVBGL(int)  VbglR0SfMapFolder(PVBGLSFCLIENT pClient, PSHFLSTRING szFolderName, PVBGLSFMAP pMap);
-DECLVBGL(int)  VbglR0SfUnmapFolder(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap);
-DECLVBGL(int)  VbglR0SfSetUtf8(PVBGLSFCLIENT pClient);
-
-DECLVBGL(int)  VbglR0SfReadLink(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, PSHFLSTRING ParsedPath, uint32_t pcbBuffer, uint8_t *pBuffer);
-DECLVBGL(int)  VbglR0SfSymlink(PVBGLSFCLIENT pClient, PVBGLSFMAP pMap, PSHFLSTRING pNewPath, PSHFLSTRING pOldPath, PSHFLFSOBJINFO pBuffer);
-DECLVBGL(int)  VbglR0SfSetSymlinks(PVBGLSFCLIENT pClient);
-
-#endif /* !___VBoxGuestLib_VBoxGuestR0LibSharedFolders_h */
-
Index: trunk/src/VBox/Additions/darwin/vboxfs/vboxvfs.h
===================================================================
--- trunk/src/VBox/Additions/darwin/vboxfs/vboxvfs.h	(revision 58202)
+++ trunk/src/VBox/Additions/darwin/vboxfs/vboxvfs.h	(revision 58203)
@@ -46,15 +46,8 @@
 #include <iprt/types.h>
 #undef PVM
-RT_C_DECLS_BEGIN
-#if defined(__cplusplus)
-# undef __cplusplus
-# include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
-# define __cplusplus
-#else
-# include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
-#endif
-RT_C_DECLS_END
-
 #include <sys/vnode.h>
+
+#include <VBox/VBoxGuestLibSharedFolders.h>
+
 
 /** Global refernce to host service connection */
Index: trunk/src/VBox/Additions/freebsd/vboxvfs/vboxvfs.h
===================================================================
--- trunk/src/VBox/Additions/freebsd/vboxvfs/vboxvfs.h	(revision 58202)
+++ trunk/src/VBox/Additions/freebsd/vboxvfs/vboxvfs.h	(revision 58203)
@@ -35,5 +35,5 @@
 #ifdef _KERNEL
 
-#include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
+#include <VBox/VBoxGuestLibSharedFolders.h>
 #include <sys/mount.h>
 #include <sys/vnode.h>
Index: trunk/src/VBox/Additions/haiku/SharedFolders/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/haiku/SharedFolders/Makefile.kmk	(revision 58202)
+++ trunk/src/VBox/Additions/haiku/SharedFolders/Makefile.kmk	(revision 58203)
@@ -67,5 +67,4 @@
         KBUILD_BASENAME=KBUILD_STR\(vboxsf\)
 vboxsf_INCS            = \
-	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib \
 	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuest \
 	$(PATH_ROOT)/src/VBox/Runtime/r0drv/haiku
Index: trunk/src/VBox/Additions/haiku/SharedFolders/vboxsf.h
===================================================================
--- trunk/src/VBox/Additions/haiku/SharedFolders/vboxsf.h	(revision 58202)
+++ trunk/src/VBox/Additions/haiku/SharedFolders/vboxsf.h	(revision 58203)
@@ -54,5 +54,5 @@
 #include <KernelExport.h>
 #include <VBoxGuest-haiku.h>
-#include <VBoxGuestR0LibSharedFolders.h>
+#include <VBox/VBoxGuestLibSharedFolders.h>
 #include "lock.h"
 
Index: trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk	(revision 58202)
+++ trunk/src/VBox/Additions/linux/sharedfolders/Makefile.kmk	(revision 58203)
@@ -59,5 +59,4 @@
 
  vboxsf_INCS            = \
- 	$(PATH_ROOT)/src/VBox/Additions/common/VBoxGuestLib \
  	$(PATH_ROOT)/src/VBox/Runtime/r0drv/linux
  vboxsf_SOURCES         = \
Index: trunk/src/VBox/Additions/linux/sharedfolders/files_vboxsf
===================================================================
--- trunk/src/VBox/Additions/linux/sharedfolders/files_vboxsf	(revision 58202)
+++ trunk/src/VBox/Additions/linux/sharedfolders/files_vboxsf	(revision 58203)
@@ -52,4 +52,5 @@
     ${PATH_ROOT}/include/VBox/VBoxGuest2.h=>include/VBox/VBoxGuest2.h \
     ${PATH_ROOT}/include/VBox/VBoxGuestLib.h=>include/VBox/VBoxGuestLib.h \
+    ${PATH_ROOT}/include/VBox/VBoxGuestLibSharedFolders.h=>include/VBox/VBoxGuestLibSharedFolders.h \
     ${PATH_ROOT}/include/VBox/VBoxGuestMangling.h=>include/VBox/VBoxGuestMangling.h \
     ${PATH_ROOT}/include/VBox/VMMDev.h=>include/VBox/VMMDev.h \
@@ -63,5 +64,4 @@
     ${PATH_ROOT}/src/VBox/Additions/common/VBoxGuestLib/VBGLInternal.h=>VBGLInternal.h \
     ${PATH_ROOT}/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.c=>VBoxGuestR0LibSharedFolders.c \
-    ${PATH_ROOT}/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h=>VBoxGuestR0LibSharedFolders.h \
     ${PATH_ROOT}/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestLog.h=>VBoxGuestLog.h \
     ${PATH_ROOT}/src/VBox/Additions/common/VBoxGuestLib/VMMDev.cpp=>VMMDev.c \
Index: trunk/src/VBox/Additions/linux/sharedfolders/vfsmod.h
===================================================================
--- trunk/src/VBox/Additions/linux/sharedfolders/vfsmod.h	(revision 58202)
+++ trunk/src/VBox/Additions/linux/sharedfolders/vfsmod.h	(revision 58203)
@@ -28,5 +28,5 @@
 #endif
 
-#include "VBoxGuestR0LibSharedFolders.h"
+#include <VBox/VBoxGuestLibSharedFolders.h>
 #include "vbsfmount.h"
 
Index: trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs.h
===================================================================
--- trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs.h	(revision 58202)
+++ trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs.h	(revision 58203)
@@ -42,5 +42,5 @@
 #ifdef _KERNEL
 
-#include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
+#include <VBox/VBoxGuestLibSharedFolders.h>
 #include <sys/vfs.h>
 
@@ -73,7 +73,7 @@
 /** Helper functions */
 extern int vboxvfs_Stat(const char *pszCaller, vboxvfs_globinfo_t *pVBoxVFSGlobalInfo, SHFLSTRING *pPath,
-            PSHFLFSOBJINFO pResult, boolean_t fAllowFailure);
+                        PSHFLFSOBJINFO pResult, boolean_t fAllowFailure);
 extern void vboxvfs_InitVNode(vboxvfs_globinfo_t *pVBoxVFSGlobalInfo, vboxvfs_vnode_t *pVBoxVNode,
-            PSHFLFSOBJINFO pFSInfo);
+                              PSHFLFSOBJINFO pFSInfo);
 
 
Index: trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c
===================================================================
--- trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c	(revision 58202)
+++ trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.c	(revision 58203)
@@ -46,5 +46,4 @@
 #undef u
 #endif
-#include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
 
 #define	SFPROV_VERSION	1
Index: trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.h
===================================================================
--- trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.h	(revision 58202)
+++ trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_prov.h	(revision 58203)
@@ -29,9 +29,9 @@
 #define	___VBoxFS_prov_Solaris_h
 
+#include <VBox/VBoxGuestLibSharedFolders.h>
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
-
-#include "../../common/VBoxGuestLib/VBoxGuestR0LibSharedFolders.h"
 
 