Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp	(revision 58204)
@@ -169,5 +169,5 @@
  * @copydoc VbglR3GetAdditionsVersion
  */
-static int vbglR3GetAdditionsCompileTimeVersion(char **ppszVer, char **ppszVerEx, char **ppszRev)
+static int vbglR3GetAdditionsCompileTimeVersion(char **ppszVer, char **ppszVerExt, char **ppszRev)
 {
     int rc = VINF_SUCCESS;
@@ -176,6 +176,6 @@
     if (RT_SUCCESS(rc))
     {
-        if (ppszVerEx)
-            rc = RTStrDupEx(ppszVerEx, VBOX_VERSION_STRING);
+        if (ppszVerExt)
+            rc = RTStrDupEx(ppszVerExt, VBOX_VERSION_STRING);
         if (RT_SUCCESS(rc))
         {
@@ -187,8 +187,8 @@
             /* bail out: */
         }
-        if (ppszVerEx)
-        {
-            RTStrFree(*ppszVerEx);
-            *ppszVerEx = NULL;
+        if (ppszVerExt)
+        {
+            RTStrFree(*ppszVerExt);
+            *ppszVerExt = NULL;
         }
     }
@@ -330,6 +330,5 @@
  * @param   fReserved       Flags reserved for future hacks.
  */
-VBGLR3DECL(int) VbglR3ReportAdditionsStatus(VBoxGuestFacilityType enmFacility,
-                                            VBoxGuestFacilityStatus enmStatusCurrent,
+VBGLR3DECL(int) VbglR3ReportAdditionsStatus(VBoxGuestFacilityType enmFacility, VBoxGuestFacilityStatus enmStatus,
                                             uint32_t fReserved)
 {
@@ -340,5 +339,5 @@
     {
         Report.guestStatus.facility = enmFacility;
-        Report.guestStatus.status   = enmStatusCurrent;
+        Report.guestStatus.status   = enmStatus;
         Report.guestStatus.flags    = fReserved;
 
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibClipboard.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibClipboard.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibClipboard.cpp	(revision 58204)
@@ -68,5 +68,5 @@
  *
  * @returns VBox status code.
- * @param   idClientId      The client id returned by VbglR3ClipboardConnect().
+ * @param   idClient        The client id returned by VbglR3ClipboardConnect().
  */
 VBGLR3DECL(int) VbglR3ClipboardDisconnect(HGCMCLIENTID idClient)
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibCredentials.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibCredentials.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibCredentials.cpp	(revision 58204)
@@ -112,5 +112,5 @@
  * @param   ppwszUser       Receives pointer of allocated user name string.
  *                          The returned pointer must be freed using VbglR3CredentialsDestroyUtf16().
- * @param   ppswzPassword   Receives pointer of allocated user password string.
+ * @param   ppwszPassword   Receives pointer of allocated user password string.
  *                          The returned pointer must be freed using VbglR3CredentialsDestroyUtf16().
  * @param   ppwszDomain     Receives pointer of allocated domain name string.
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestCtrl.cpp	(revision 58204)
@@ -280,8 +280,8 @@
  * @return  IPRT status code.
  * @param   pCtx                    Host context.
- * @param   uFlags
+ * @param   fFlags                  Some kind of flag. Figure it out yourself.
  ** @todo Docs!
  */
-VBGLR3DECL(int) VbglR3GuestCtrlSessionClose(PVBGLR3GUESTCTRLCMDCTX pCtx, uint32_t uFlags)
+VBGLR3DECL(int) VbglR3GuestCtrlSessionClose(PVBGLR3GUESTCTRLCMDCTX pCtx, uint32_t fFlags)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -296,5 +296,5 @@
 
     VbglHGCMParmUInt32Set(&Msg.context, pCtx->uContextID);
-    VbglHGCMParmUInt32Set(&Msg.flags, uFlags);
+    VbglHGCMParmUInt32Set(&Msg.flags, fFlags);
 
     int rc = vbglR3DoIOCtl(VBOXGUEST_IOCTL_HGCM_CALL(sizeof(Msg)), &Msg, sizeof(Msg));
@@ -340,5 +340,4 @@
  *
  * @return  IPRT status code.
- * @param   pCtx                    Host context.
  ** @todo Docs!
  */
@@ -348,5 +347,5 @@
                                               char     *pszPassword, uint32_t  cbPassword,
                                               char     *pszDomain,   uint32_t  cbDomain,
-                                              uint32_t *puFlags,     uint32_t *puSessionID)
+                                              uint32_t *pfFlags,     uint32_t *pidSession)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -357,5 +356,5 @@
     AssertPtrReturn(pszPassword, VERR_INVALID_POINTER);
     AssertPtrReturn(pszDomain, VERR_INVALID_POINTER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
 
     HGCMMsgSessionOpen Msg;
@@ -385,8 +384,8 @@
             Msg.context.GetUInt32(&pCtx->uContextID);
             Msg.protocol.GetUInt32(puProtocol);
-            Msg.flags.GetUInt32(puFlags);
-
-            if (puSessionID)
-                *puSessionID = VBOX_GUESTCTRL_CONTEXTID_GET_SESSION(pCtx->uContextID);
+            Msg.flags.GetUInt32(pfFlags);
+
+            if (pidSession)
+                *pidSession = VBOX_GUESTCTRL_CONTEXTID_GET_SESSION(pCtx->uContextID);
         }
     }
@@ -400,13 +399,12 @@
  *
  * @return  IPRT status code.
- * @param   pCtx                    Host context.
  ** @todo Docs!
  */
-VBGLR3DECL(int) VbglR3GuestCtrlSessionGetClose(PVBGLR3GUESTCTRLCMDCTX pCtx, uint32_t *puFlags, uint32_t *puSessionID)
+VBGLR3DECL(int) VbglR3GuestCtrlSessionGetClose(PVBGLR3GUESTCTRLCMDCTX pCtx, uint32_t *pfFlags, uint32_t *pidSession)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
     AssertReturn(pCtx->uNumParms == 2, VERR_INVALID_PARAMETER);
 
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
 
     HGCMMsgSessionClose Msg;
@@ -431,8 +429,8 @@
         {
             Msg.context.GetUInt32(&pCtx->uContextID);
-            Msg.flags.GetUInt32(puFlags);
-
-            if (puSessionID)
-                *puSessionID = VBOX_GUESTCTRL_CONTEXTID_GET_SESSION(pCtx->uContextID);
+            Msg.flags.GetUInt32(pfFlags);
+
+            if (pidSession)
+                *pidSession = VBOX_GUESTCTRL_CONTEXTID_GET_SESSION(pCtx->uContextID);
         }
     }
@@ -445,5 +443,5 @@
                                              char     *pszSource,       uint32_t cbSource,
                                              char     *pszDest,         uint32_t cbDest,
-                                             uint32_t *puFlags)
+                                             uint32_t *pfFlags)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -454,5 +452,5 @@
     AssertPtrReturn(pszDest, VERR_INVALID_POINTER);
     AssertReturn(cbDest, VERR_INVALID_PARAMETER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
 
     HGCMMsgPathRename Msg;
@@ -479,5 +477,5 @@
         {
             Msg.context.GetUInt32(&pCtx->uContextID);
-            Msg.flags.GetUInt32(puFlags);
+            Msg.flags.GetUInt32(pfFlags);
         }
     }
@@ -497,5 +495,5 @@
 VBGLR3DECL(int) VbglR3GuestCtrlProcGetStart(PVBGLR3GUESTCTRLCMDCTX    pCtx,
                                             char     *pszCmd,         uint32_t  cbCmd,
-                                            uint32_t *puFlags,
+                                            uint32_t *pfFlags,
                                             char     *pszArgs,        uint32_t  cbArgs,     uint32_t *pcArgs,
                                             char     *pszEnv,         uint32_t *pcbEnv,     uint32_t *pcEnvVars,
@@ -509,5 +507,5 @@
 
     AssertPtrReturn(pszCmd, VERR_INVALID_POINTER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
     AssertPtrReturn(pszArgs, VERR_INVALID_POINTER);
     AssertPtrReturn(pcArgs, VERR_INVALID_POINTER);
@@ -565,5 +563,5 @@
         {
             Msg.context.GetUInt32(&pCtx->uContextID);
-            Msg.flags.GetUInt32(puFlags);
+            Msg.flags.GetUInt32(pfFlags);
             Msg.num_args.GetUInt32(pcArgs);
             Msg.num_env.GetUInt32(pcEnvVars);
@@ -594,5 +592,5 @@
  */
 VBGLR3DECL(int) VbglR3GuestCtrlProcGetOutput(PVBGLR3GUESTCTRLCMDCTX pCtx,
-                                             uint32_t *puPID, uint32_t *puHandle, uint32_t *puFlags)
+                                             uint32_t *puPID, uint32_t *puHandle, uint32_t *pfFlags)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -601,5 +599,5 @@
     AssertPtrReturn(puPID, VERR_INVALID_POINTER);
     AssertPtrReturn(puHandle, VERR_INVALID_POINTER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
 
     HGCMMsgProcOutput Msg;
@@ -628,5 +626,5 @@
             Msg.pid.GetUInt32(puPID);
             Msg.handle.GetUInt32(puHandle);
-            Msg.flags.GetUInt32(puFlags);
+            Msg.flags.GetUInt32(pfFlags);
         }
     }
@@ -645,5 +643,5 @@
  */
 VBGLR3DECL(int) VbglR3GuestCtrlProcGetInput(PVBGLR3GUESTCTRLCMDCTX  pCtx,
-                                            uint32_t  *puPID,       uint32_t *puFlags,
+                                            uint32_t  *puPID,       uint32_t *pfFlags,
                                             void      *pvData,      uint32_t  cbData,
                                             uint32_t  *pcbSize)
@@ -653,5 +651,5 @@
 
     AssertPtrReturn(puPID, VERR_INVALID_POINTER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
     AssertPtrReturn(pvData, VERR_INVALID_POINTER);
     AssertPtrReturn(pcbSize, VERR_INVALID_POINTER);
@@ -682,5 +680,5 @@
             Msg.context.GetUInt32(&pCtx->uContextID);
             Msg.pid.GetUInt32(puPID);
-            Msg.flags.GetUInt32(puFlags);
+            Msg.flags.GetUInt32(pfFlags);
             Msg.size.GetUInt32(pcbSize);
         }
@@ -692,5 +690,5 @@
 VBGLR3DECL(int) VbglR3GuestCtrlDirGetRemove(PVBGLR3GUESTCTRLCMDCTX     pCtx,
                                             char     *pszPath,         uint32_t cbPath,
-                                            uint32_t *puFlags)
+                                            uint32_t *pfFlags)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -699,5 +697,5 @@
     AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
     AssertReturn(cbPath, VERR_INVALID_PARAMETER);
-    AssertPtrReturn(puFlags, VERR_INVALID_POINTER);
+    AssertPtrReturn(pfFlags, VERR_INVALID_POINTER);
 
     HGCMMsgDirRemove Msg;
@@ -723,5 +721,5 @@
         {
             Msg.context.GetUInt32(&pCtx->uContextID);
-            Msg.flags.GetUInt32(puFlags);
+            Msg.flags.GetUInt32(pfFlags);
         }
     }
@@ -1344,5 +1342,5 @@
  */
 VBGLR3DECL(int) VbglR3GuestCtrlProcCbStatus(PVBGLR3GUESTCTRLCMDCTX pCtx,
-                                            uint32_t uPID, uint32_t uStatus, uint32_t uFlags,
+                                            uint32_t uPID, uint32_t uStatus, uint32_t fFlags,
                                             void  *pvData, uint32_t cbData)
 {
@@ -1359,5 +1357,5 @@
     VbglHGCMParmUInt32Set(&Msg.pid, uPID);
     VbglHGCMParmUInt32Set(&Msg.status, uStatus);
-    VbglHGCMParmUInt32Set(&Msg.flags, uFlags);
+    VbglHGCMParmUInt32Set(&Msg.flags, fFlags);
     VbglHGCMParmPtrSet(&Msg.data, pvData, cbData);
 
@@ -1380,5 +1378,5 @@
  */
 VBGLR3DECL(int) VbglR3GuestCtrlProcCbOutput(PVBGLR3GUESTCTRLCMDCTX pCtx,
-                                            uint32_t uPID,uint32_t uHandle, uint32_t uFlags,
+                                            uint32_t uPID,uint32_t uHandle, uint32_t fFlags,
                                             void *pvData, uint32_t cbData)
 {
@@ -1395,5 +1393,5 @@
     VbglHGCMParmUInt32Set(&Msg.pid, uPID);
     VbglHGCMParmUInt32Set(&Msg.handle, uHandle);
-    VbglHGCMParmUInt32Set(&Msg.flags, uFlags);
+    VbglHGCMParmUInt32Set(&Msg.flags, fFlags);
     VbglHGCMParmPtrSet(&Msg.data, pvData, cbData);
 
@@ -1417,5 +1415,5 @@
 VBGLR3DECL(int) VbglR3GuestCtrlProcCbStatusInput(PVBGLR3GUESTCTRLCMDCTX pCtx,
                                                  uint32_t uPID, uint32_t uStatus,
-                                                 uint32_t uFlags, uint32_t cbWritten)
+                                                 uint32_t fFlags, uint32_t cbWritten)
 {
     AssertPtrReturn(pCtx, VERR_INVALID_POINTER);
@@ -1431,5 +1429,5 @@
     VbglHGCMParmUInt32Set(&Msg.pid, uPID);
     VbglHGCMParmUInt32Set(&Msg.status, uStatus);
-    VbglHGCMParmUInt32Set(&Msg.flags, uFlags);
+    VbglHGCMParmUInt32Set(&Msg.flags, fFlags);
     VbglHGCMParmUInt32Set(&Msg.written, cbWritten);
 
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestProp.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestProp.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibGuestProp.cpp	(revision 58204)
@@ -328,5 +328,5 @@
  *                          Optional.
  * @param   pu64Timestamp   Where to store the timestamp.  Optional.
- * @param   pszFlags        Where to store the pointer to the flags.  Optional.
+ * @param   ppszFlags       Where to store the pointer to the flags.  Optional.
  * @param   pcbBufActual    If @a pcBuf is not large enough, the size needed.
  *                          Optional.
@@ -521,5 +521,5 @@
  * @returns VBox status code.
  * @retval  VINF_SUCCESS on success and pcBuf points to a packed array
- *          of the form <name>, <value>, <timestamp string>, <flags>,
+ *          of the form \<name\>, \<value\>, \<timestamp string\>, \<flags\>,
  *          terminated by four empty strings.  pcbBufActual will contain the
  *          total size of the array.
@@ -529,5 +529,5 @@
  *
  * @param   idClient      The client ID returned by VbglR3GuestPropConnect
- * @param   paszPatterns  A packed array of zero terminated strings, terminated
+ * @param   pszzPatterns  A packed array of zero terminated strings, terminated
  *                        by an empty string.
  * @param   pcBuf         The buffer to store the results to.
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibMisc.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibMisc.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibMisc.cpp	(revision 58204)
@@ -38,5 +38,5 @@
  * @returns IPRT status code.
  * @param   fOr     The OR mask.
- * @param   fNo     The NOT mask.
+ * @param   fNot    The NOT mask.
  */
 VBGLR3DECL(int) VbglR3CtlFilterMask(uint32_t fOr, uint32_t fNot)
Index: trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp
===================================================================
--- trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp	(revision 58203)
+++ trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibVideo.cpp	(revision 58204)
@@ -154,5 +154,5 @@
  * @param   pcBits      Where to store the bits per pixel requested (a value
  *                      of zero means do not change).
- * @param   iDisplay    Where to store the display number the request was for
+ * @param   piDisplay   Where to store the display number the request was for
  *                      - 0 for the primary display, 1 for the first
  *                      secondary display, etc.
@@ -213,9 +213,8 @@
  * @param   pdy         New vertical position of the secondary monitor.
  *                      Optional.
- * param    pfEnabled   Secondary monitor is enabled or not.
- *                      Optional.
- * param    pfChangeOrigin  Whether the mode hint retrieved included information
- *                      about origin/display offset inside the frame-buffer.
- *                      Optional.
+ * @param   pfEnabled   Secondary monitor is enabled or not. Optional.
+ * @param   pfChangeOrigin  Whether the mode hint retrieved included
+ *                      information about origin/display offset inside the
+ *                      frame-buffer. Optional.
  *
  */