Index: trunk/src/VBox/Installer/linux/debian/preinst
===================================================================
--- trunk/src/VBox/Installer/linux/debian/preinst	(revision 58262)
+++ trunk/src/VBox/Installer/linux/debian/preinst	(revision 58262)
@@ -0,0 +1,66 @@
+#!/bin/bash
+#
+# Copyright (C) 2006-2015 Oracle Corporation
+#
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+
+# we can be called with the following arguments (6.5 of Debian policy):
+#  install:          (our version): install our version
+#  upgrade:          (our version): upgrade to our version
+#  abort-upgrade:    (old version): upgrade to a new version failed
+
+# defaults
+[ -r /etc/default/virtualbox ] && . /etc/default/virtualbox
+
+if [ "$1" = "install" -o "$1" = "upgrade" ]; then
+
+  . /usr/share/debconf/confmodule
+  db_version 2.0
+  db_capb backup
+
+  # check for old installation
+  if [ -r /etc/vbox/vbox.cfg ]; then
+    . /etc/vbox/vbox.cfg
+    if [ "x$INSTALL_DIR" != "x" -a -d "$INSTALL_DIR" ]; then
+      db_fset virtualbox/old-installation-found seen false || true
+      db_input critical virtualbox/old-installation-found || true
+      db_go || true
+      exit 1
+    fi
+    # we will remove that file in postinst
+  fi
+
+  # check for active VMs
+  # Execute the installed package's pre-uninstaller if present.
+  /usr/lib/virtualbox/prerm-common.sh 2>/dev/null || true
+  # Stop services from older versions without pre-uninstaller.
+  invoke-rc.d vboxballoonctrl-service stop 2>/dev/null || true
+  /etc/init.d/vboxballoonctrl-service stop 2>/dev/null || true
+  invoke-rc.d vboxautostart-service stop 2>/dev/null || true
+  /etc/init.d/vboxautostart-service stop 2>/dev/null || true
+  invoke-rc.d vboxweb-service stop 2>/dev/null || true
+  /etc/init.d/vboxweb-service stop 2>/dev/null || true
+  VBOXSVC_PID=`pidof VBoxSVC 2>/dev/null || true`
+  if [ -n "$VBOXSVC_PID" ]; then
+    # ask the daemon to terminate immediately
+    kill -USR1 $VBOXSVC_PID
+    sleep 1
+    if pidof VBoxSVC > /dev/null 2>&1; then
+      db_fset virtualbox/old-running seen false || true
+      db_input critical virtualbox/old-running || true
+      db_go || true
+      exit 1
+    fi
+  fi
+
+fi # "$1" = "install" -o "$1" = "upgrade"
+
+#DEBHELPER#
+
Index: trunk/src/VBox/Installer/linux/debian/preinst.in
===================================================================
--- trunk/src/VBox/Installer/linux/debian/preinst.in	(revision 58261)
+++ 	(revision )
@@ -1,66 +1,0 @@
-#!/bin/bash
-#
-# Copyright (C) 2006-2015 Oracle Corporation
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-
-# we can be called with the following arguments (6.5 of Debian policy):
-#  install:          (our version): install our version
-#  upgrade:          (our version): upgrade to our version
-#  abort-upgrade:    (old version): upgrade to a new version failed
-
-# defaults
-[ -r /etc/default/virtualbox ] && . /etc/default/virtualbox
-
-if [ "$1" = "install" -o "$1" = "upgrade" ]; then
-
-  . /usr/share/debconf/confmodule
-  db_version 2.0
-  db_capb backup
-
-  # check for old installation
-  if [ -r /etc/vbox/vbox.cfg ]; then
-    . /etc/vbox/vbox.cfg
-    if [ "x$INSTALL_DIR" != "x" -a -d "$INSTALL_DIR" ]; then
-      db_fset virtualbox/old-installation-found seen false || true
-      db_input critical virtualbox/old-installation-found || true
-      db_go || true
-      exit 1
-    fi
-    # we will remove that file in postinst
-  fi
-
-  # check for active VMs
-  # Execute the installed package's pre-uninstaller if present.
-  /usr/lib/virtualbox/prerm-common.sh 2>/dev/null || true
-  # Stop services from older versions without pre-uninstaller.
-  invoke-rc.d vboxballoonctrl-service stop 2>/dev/null || true
-  /etc/init.d/vboxballoonctrl-service stop 2>/dev/null || true
-  invoke-rc.d vboxautostart-service stop 2>/dev/null || true
-  /etc/init.d/vboxautostart-service stop 2>/dev/null || true
-  invoke-rc.d vboxweb-service stop 2>/dev/null || true
-  /etc/init.d/vboxweb-service stop 2>/dev/null || true
-  VBOXSVC_PID=`pidof VBoxSVC 2>/dev/null || true`
-  if [ -n "$VBOXSVC_PID" ]; then
-    # ask the daemon to terminate immediately
-    kill -USR1 $VBOXSVC_PID
-    sleep 1
-    if pidof VBoxSVC > /dev/null 2>&1; then
-      db_fset virtualbox/old-running seen false || true
-      db_input critical virtualbox/old-running || true
-      db_go || true
-      exit 1
-    fi
-  fi
-
-fi # "$1" = "install" -o "$1" = "upgrade"
-
-#DEBHELPER#
-
Index: trunk/src/VBox/Installer/linux/debian/prerm
===================================================================
--- trunk/src/VBox/Installer/linux/debian/prerm	(revision 58262)
+++ trunk/src/VBox/Installer/linux/debian/prerm	(revision 58262)
@@ -0,0 +1,43 @@
+#!/bin/sh
+
+#
+# Copyright (C) 2006-2015 Oracle Corporation
+#
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+
+# we can be called with the following arguments (6.5 of Debian policy):
+#  upgrade:          (new version): upgrade to a new version
+#  failed-upgrade:   (our version): failed to upgrade
+#  remove:           (our version): remove this package
+#  deconfigure:      (our version): removing conflicting version
+
+rm -f /etc/udev/rules.d/60-vboxdrv.rules
+rm -f /etc/vbox/license_agreed
+rm -f /etc/vbox/module_not_compiled
+
+# defaults
+[ -r /etc/default/virtualbox ] && . /etc/default/virtualbox
+
+. /usr/share/debconf/confmodule
+db_version 2.0
+db_capb backup
+
+if ! /usr/lib/virtualbox/prerm-common.sh > /dev/null 2>&1; then
+  if [ "$1" != "failed-upgrade" ]; then
+    db_fset virtualbox/old-running seen false || true
+    db_input critical virtualbox/old-running || true
+    db_go || true
+  fi
+  exit 1
+fi
+
+#DEBHELPER#
+
+exit 0
Index: trunk/src/VBox/Installer/linux/debian/prerm.in
===================================================================
--- trunk/src/VBox/Installer/linux/debian/prerm.in	(revision 58261)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#!/bin/sh
-
-#
-# Copyright (C) 2006-2015 Oracle Corporation
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-
-# we can be called with the following arguments (6.5 of Debian policy):
-#  upgrade:          (new version): upgrade to a new version
-#  failed-upgrade:   (our version): failed to upgrade
-#  remove:           (our version): remove this package
-#  deconfigure:      (our version): removing conflicting version
-
-rm -f /etc/udev/rules.d/60-vboxdrv.rules
-rm -f /etc/vbox/license_agreed
-rm -f /etc/vbox/module_not_compiled
-
-# defaults
-[ -r /etc/default/virtualbox ] && . /etc/default/virtualbox
-
-. /usr/share/debconf/confmodule
-db_version 2.0
-db_capb backup
-
-if ! /usr/lib/virtualbox/prerm-common.sh > /dev/null 2>&1; then
-  if [ "$1" != "failed-upgrade" ]; then
-    db_fset virtualbox/old-running seen false || true
-    db_input critical virtualbox/old-running || true
-    db_go || true
-  fi
-  exit 1
-fi
-
-#DEBHELPER#
-
-exit 0
Index: trunk/src/VBox/Installer/linux/debian/rules
===================================================================
--- trunk/src/VBox/Installer/linux/debian/rules	(revision 58261)
+++ trunk/src/VBox/Installer/linux/debian/rules	(revision 58262)
@@ -191,5 +191,4 @@
 	dh_testroot
 	rm -f debian/changelog
-	rm -f debian/preinst debian/prerm
 	rm -f debian/AutoConfig.kmk debian/configure.log debian/env.sh
 	rm -f debian/modules-stamp debian/build-stamp debian/configure-stamp
@@ -259,8 +258,4 @@
 	    -e 's|%VERPKG%|$(verpkg)|g' \
 	    debian/changelog.in > debian/changelog
-	sed -e 's|%VER%|$(ver)|g' \
-	    debian/preinst.in > debian/preinst
-	sed -e 's|%VER%|$(ver)|g' \
-	    debian/prerm.in > debian/prerm
 	dh_installdebconf
 	dh_installchangelogs